/*
	Copyright Andrew Varner 2011.07.22

	This file is part of rohttpfs.

	rohttpfs is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License version 3 as
	published by the Free Software Foundation.

	rohttpfs is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with rohttpfs.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef ROHTTPFS_MAIN_H
#define ROHTTPFS_MAIN_H

#define FUSE_USE_VERSION 26

#include <sys/types.h>
#include <sys/socket.h>
#include <stdint.h>
#include <stdio.h>
#include <stdbool.h>

extern int uid;
extern int gid;

extern FILE * logfile;
extern struct sockaddr_in remote_host;

#define max_dir_index_size 500000
#define REMOTE_HOST "192.168.0.80"
#define MAX_AGE_OF_FILE 5400
#define MAX_AGE_OF_DIR 300
#define NUM_OPEN_FILES_MAX 5000
#define BLOCK_SIZE 1048576
#define MAX_MEMORY 100000000




#ifdef __cplusplus
extern "C" {
#endif

bool are_there_sublinks(const char * data/*, const char * path, const char * basepath*/);
bool is_this_ascii(const char * data, size_t length);
bool is_this_a_dir_redirect(const char * path, const char * redirected_url);
int ping_server(void);

#ifdef __cplusplus
}
#endif



#define IS_SIGNED(type)	((((type)-1)<0)?1:0)
#define MAX_OF(type)	((type)((((__uint128_t)1) << (8 * sizeof(type) - IS_SIGNED(type)))-1))

#define INT_MAX		MAX_OF(int)

#define SIZE_UNDEFINED	(size_t)(-1)

#endif

