/*
	Copyright Andrew Varner 2011.07.22

	This file is part of rohttpfs.

	rohttpfs is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License version 3 as
	published by the Free Software Foundation.

	rohttpfs is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with rohttpfs.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "main.h"

#include <sys/types.h>
#include <regex.h>
#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>




static volatile int init = 0;
static pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
static regex_t regex1;


bool are_there_sublinks(const char * data/*, const char * path, const char * basepath*/)
{
	if (!init)
	{
		pthread_mutex_lock(&mutex);
		if (!init)
		{
			if (regcomp(&regex1, "<[aA]([ \t\n]+[a-zA-Z0-9._-]+[=](\"[^\"]*\"|\'[^\']*\'|[^ \t\n]*))*[ \t\n]+href[=](\"([^\"]*)\\1\"|\'([^\']*)\\1\'|([^ \t\n]*)\\1)", REG_EXTENDED) != 0)
			{
				perror("compile regex error");
				exit(2);
			}
			init = 1;
		}
		pthread_mutex_unlock(&mutex);
	}
	
	const size_t nmatch = 500;
	regmatch_t pmatch[nmatch];
	memset(&pmatch, 0, sizeof(pmatch));
	int status = regexec(&regex1, data, 0, NULL, 0);
	if (status == REG_NOMATCH)
		return 0;
	if (status != 0)
	{
		perror("run regex error");
		exit(2);
	}
	//"href[=]([^ \t\n]*|[\"][^ \t\n]*[\"]|[\'][^ \t\n]*[\'])";
	return 1;
}



/*
TODO: check for these path types:
afile
./afile
../thisdir/afile (not needed?)
/nondomainpartofbasepath/path/afile
http://basepathdomain.example/basepath/path/afile
*/

